local addonName, TF = ...

local TradeFill = LibStub("AceAddon-3.0"):GetAddon(addonName)
local Loc = LibStub("AceLocale-3.0"):GetLocale("TradeFill")

function TradeFill:TRADE_SHOW()
    if not TradeFrame:IsVisible() then
        CancelTrade()

        return
    else
        local target, _ = UnitName("npc")
        local className, classFile, _ = UnitClass("npc")

        TF.name = target
        TF.level = UnitLevel("npc")
        TF.guild = GetGuildInfo("npc")
        TF.class = { ["name"] = className, ["file"] = classFile }
        TF.item = TF.data.item
        TF.stack = TradeFill.db.profile.stacks[classFile]

        self:RegisterEvent("TRADE_CLOSED")
        self:RegisterEvent("UI_INFO_MESSAGE")
        self:RegisterEvent("BAG_UPDATE_DELAYED")
        self:RegisterEvent("SECURE_TRANSFER_CANCEL")
        self:RegisterEvent("TRADE_ACCEPT_UPDATE")

        searchInventory()
        ButtonInitialize()

        local group = groupCondition()

        local stranger = TradeFill.db.profile.setting.solo
        local party = TradeFill.db.profile.setting.party
        local raid = TradeFill.db.profile.setting.raid

        if (stranger == true and group.status == "solo") then

            if tradingCondition() then
                return
            end

            for key = 1, MAX_TRADABLE_ITEMS do
                local index = tostring(key)

                if TF.item[index].id > 0 and TF.stack[index] > 0 then
                    ItemCondition(TF.stack[index], TF.item[index])
                end
            end
            return
        end

        if (party == true and group.status == "party") or (raid == true and group.status == "raid") then

            if tradingCondition() then
                return
            end

            local numGroupMembers = GetNumGroupMembers()

            if numGroupMembers > 0 then
                for i = 1, numGroupMembers do
                    local unitName, _ = UnitName(group.status .. i)

                    if unitName == TF.name then

                        for key = 1, MAX_TRADABLE_ITEMS do
                            local index = tostring(key)

                            if TF.item[index].id > 0 and TF.stack[index] > 0 then
                                ItemCondition(TF.stack[index], TF.item[index])
                            end
                        end
                        break
                    end
                end
            end
        end
    end
end

function TradeFill:TRADE_ACCEPT_UPDATE(event, sender, receiver)
    if sender == 1 or receiver == 1 then
        TradeFill:getTradeHistory()
    end
end

function TradeFill:UI_INFO_MESSAGE(event, index, info)
    if info == 	"Trade complete."  then
        showMessage(string.format(Loc["TRADE_COMPLETE"], getName()), false)
        TradeFill:setTradeHistory()
    end

    if info == "Trade cancelled." then
        showMessage(string.format(Loc["TRADE_CANCELED"], getName()), false)
    end
end

function TradeFill:BAG_UPDATE_DELAYED()
    clearTade()

    TradeFill:TRADE_SHOW()
end

function TradeFill:SECURE_TRANSFER_CANCEL()
    ButtonUpdate()
end

function TradeFill:TRADE_CLOSED()
    messageAppear = {}

    TradeFill:UnregisterEvent("BAG_UPDATE_DELAYED")
    TradeFill:UnregisterEvent("SECURE_TRANSFER_CANCEL")
end